const Me = imports.misc.extensionUtils.getCurrentExtension();

const Apps     = Me.imports.apps;
const Corners  = Me.imports.corners;
const Hack     = Me.imports.hack;
const Prefs    = Me.imports.prefs;
const Style    = Me.imports.style;
const UserMenu = Me.imports.userMenu;
const View     = Me.imports.view;

function init() {
    Prefs.init();

    Hack.init();

    Apps.init();
    UserMenu.init();

    View.init();
    Corners.init(); // depends on View
}

function enable() {
    Style.enable();
    Hack.enable();

    Apps.enable();
    UserMenu.enable();

    View.enable();
    Corners.enable();
}

function disable() {
    Style.disable();
    Hack.disable();

    Apps.disable();
    UserMenu.disable();

    View.disable();
    Corners.disable();
}
