const Me           = imports.misc.extensionUtils.getCurrentExtension();
const Overview     = imports.ui.main.overview;
const ViewSelector = imports.ui.main.overview._viewSelector;

const Apps  = Me.imports.apps;
const Prefs = Me.imports.prefs;

let applications = {};
let workspaces   = {};
let search       = {};
let undos        = [];

function init() {
    function toggle(page) {
        function toggle() {
            Overview.toggle();
            return Overview.visible;
        }
        return function() {
            if (Overview.visible && ViewSelector._searchCancelled != page || toggle()) {
                ViewSelector._searchCancelled = page;
                ViewSelector._entry.text = '';
                ViewSelector._text.set_cursor_visible(true);
                ViewSelector._text.set_selection(0, 0);
                page();
            }
        };
    }

    workspaces = {
        toggle : toggle(function() {
            ViewSelector._activePage = ViewSelector._searchPage;
            ViewSelector._showPage(ViewSelector._workspacesPage);
        })
    };
    search = {
        toggle : toggle(function() {
            ViewSelector._searchResults.reset();
            ViewSelector._showPage(ViewSelector._searchPage);
        })
    };
    applications = {
        toggle : toggle(function() {
            ViewSelector._searchResults.doSearch(Apps.SEARCH_CATEGORY);
            ViewSelector._showPage(ViewSelector._searchPage);
        })
    };
}

function enable() {
    let clear = let (
        searchCancelled = ViewSelector._searchCancelled
    ) function() {
        ViewSelector._searchCancelled = searchCancelled;
        ViewSelector._entry.text = '';
        ViewSelector._text.set_cursor_visible(true);
        ViewSelector._text.set_selection(0, 0);
    };

    undos.push(
        clear,
        Prefs.connect(Overview, 'hiding', clear),
        Prefs.connect(ViewSelector._showAppsButton, 'notify::checked', clear)
    );
}

function disable() {
    while(undos.length > 0) {
        undos.pop()();
    }
}
